\documentclass[12pt,
               fleqn,
               %twoside,
               a4paper]
               {config/MyReport}

% For two-sided comment in twoside above, change the margins in 
% config/margins.tex and comment in pdfpagelayout=TwoPageRight 
% in the hyperref package config. For one-sided do the opposite.

\def\ThesisTitle{Space-time multi-level $hp$-finite elements for heat evolution in laser powder bed fusion additive manufacturing}

% ----------- Packages --------------

\usepackage{siunitx}
\usepackage{placeins}
\usepackage{caption, subcaption}
\usepackage{cancel}

\usepackage{graphicx}
\usepackage{amsmath}
\usepackage[T1]{fontenc}
\usepackage[outline]{contour}
\usepackage{lmodern}
\usepackage{xcolor}
\usepackage{booktabs}
\usepackage{adjustbox}
\usepackage{rotating}
%\setlength{\parskip}{\baselineskip}%
%\setlength{\parindent}{0pt}%

\allowdisplaybreaks

\newtheorem{theorem}{Theorem}[section]
\newtheorem{remark}[theorem]{Remark}


% ----------- Colors --------------
\usepackage{xcolor} 
\definecolor{lightblue}{rgb}{0,0.5,1.0}
\definecolor{linkblue}{rgb}{0,0.1,0.6}
\definecolor{citegreen}{rgb}{0,0.4,0.0}%{0.1,0.5,0.4}%{0.125,0.6,0.5}
\definecolor{linkred}{rgb}{0.8,0,0.005}%{0.6,0,0.1}
\definecolor{mailviolet}{rgb}{0.3,0,0.35}%{0.6,0,0.1}
\definecolor{tumblue}{rgb}{0,0.396,0.741}
\definecolor{darkgreen}{rgb}{0,0.5,0} 
\definecolor{nicegreen}{rgb}{0,0.6,0} 
\definecolor{darkbrown}{rgb}{0.5, 0.396, 0.09}

% ----------- pgf / tikz --------------
\usepackage{pgfplots}
\usepackage{pgfplotstable}
\usepackage{tikz}
\usepackage{tikzscale}
\usepackage{tikz-3dplot}
\usepackage{marvosym}% for \Lightning

\pgfplotsset{compat=1.5}

\usetikzlibrary{spy}
\usetikzlibrary{intersections}
\usetikzlibrary{arrows,shapes}
\usetikzlibrary{spy}
\usetikzlibrary{backgrounds}  
\usetikzlibrary{decorations}
\usetikzlibrary{decorations.markings}
\usetikzlibrary{positioning}
\usetikzlibrary{calligraphy}
\usetikzlibrary{patterns}
\usetikzlibrary{calc} 
\usetikzlibrary{quotes} 
\usetikzlibrary{external} % Is activated with the command '\tikzexternalize'.
\usetikzlibrary{matrix}
\usepgfplotslibrary{groupplots}

\pgfplotscreateplotcyclelist{customCycleList}
{%
  {blue, mark=o},
  {red, mark=square},
  {nicegreen, mark=diamond},
  {cyan, mark=diamond},
  {darkbrown, mark=triangle*},
  {black, mark=pentagon},
}

\pgfplotsset{every axis/.append style= {
    cycle list name=customCycleList,
}}

\newcommand{\includePng}[2]{\includegraphics[#1]{\picsDir/#2.png}}
\newcommand{\includeJpg}[2]{\includegraphics[#1]{\picsDir/#2.jpg}}

%\newcommand{\includeTikz}[2]{\includegraphics[#1]{tikz/#2.pdf}}%
\newcommand{\includeTikz}[2]{\tikzsetnextfilename{#2}%
                             \includegraphics[#1]{\picsDir/#2.tikz}}%

\newcommand{\reprintedA}{From~\textcite{Kopp2022a}, used under Creative Commons CC BY 4.0 license.}
\newcommand{\reprintedB}{From~\textcite{Kopp2022b}, used under Creative Commons CC BY 4.0 license.}
\newcommand{\reprintedC}{From~\textcite{Harkin22}, used under Creative Commons CC BY 4.0 license.}
\newcommand{\reprintedD}{From~\textcite{Rongzeng2018}, used under Creative Commons CC BY 4.0 license.}
\newcommand{\reprintedE}{From~\textcite{Letenneur2017}, used under Creative Commons CC BY 4.0 license.}
\newcommand{\reprintedF}{From~\textcite{Rausch2017}, used under Creative Commons CC BY 4.0 license.}
\newcommand{\reprintedG}{From~\textcite{Bayat2019}, used under Creative Commons CC BY-NC-ND 4.0 license.}
\newcommand{\reprintedH}{From~\textcite{Gordon2020}, used under Creative Commons CC BY-NC-ND 4.0 license.}

\newcommand{\CopiedChapter}[2]{\chapter[#2]{#2\protect#1}}
\newcommand{\CopiedSection}[2]{\section[#2]{#2\protect#1}}

%\newcommand{\deletedC}[1]{}
\newcommand{\review}[1]{#1}
%\newcommand{\review}[1]{\textcolor{blue}{#1}}
%\newcommand{\deleted}[1]{}

% ---------------------
\usepackage{listings}
\usepackage{algorithm}

\definecolor{colKeys}{RGB}{0,0,255}       % blue
%\definecolor{colEmph}{rgb}{0, 0.75, 0.75} % purple
\definecolor{colEmph}{RGB}{160,32,240} % purple
\definecolor{colIdentifier}{RGB}{0,0,0}   % black
\definecolor{colComments}{RGB}{34,139,34} % green
\definecolor{colString}{RGB}{160,32,240}  % violet
\newcommand{\comment}[1]{\textcolor{colComments}{#1}}
\newcommand{\codesize}{\fontsize{9pt}{11pt}\selectfont}

\lstset{%
    language=C,%
    backgroundcolor={\color{gray!5}},%
    basicstyle={\codesize\ttfamily},%
    breakautoindent=true,%
    breakindent=10pt,%
    breaklines=true,%
    captionpos=b,%
    columns=fixed,%
    commentstyle={\color{colComments}},%
    extendedchars=true,%
    float=hbp,%
    %frame=tb,%
    framerule=0.25pt,%
    identifierstyle={\color{colIdentifier}},%
    keywordstyle={\color{colKeys}},%
    emphstyle={\color{colEmph}},%
    numbers=left,%
    numbersep=1em,%
    numberstyle={\codesize\ttfamily},%
    numberblanklines=true,
    showspaces=false,%
    showstringspaces=false,%
    stringstyle={\color{colString}},%
    tabsize=4,%
    xleftmargin=1em,%
    xrightmargin=0em,
    numberstyle=\codesize,
    morekeywords={public, void, each, of, ==, true, function, false, bool, not, and, or, from, to, in},
	moreemph={Mask, MaskList, LocationMatrix, LocationMatrixList, NdArray, NdArrayList, Op, Vector, Neighbors, Degrees, String, Levels, Isleaf, Type, Mesh, LeafId, Coords, Diff, VectorList},
}

% ---------------------

\newcommand{\clearemptydoublepage}{\newpage{\pagestyle{empty}\cleardoublepage}}
\definecolor{LinkColor}{rgb}{0,0.1,0.6}
\usepackage[
    %pdftex,
    pdftitle={\ThesisTitle},
    pdfauthor={Philipp Kopp},
    pdfsubject={},
    pdfcreator={},
    pdfproducer={},
    pdfkeywords={},
    %pdfpagelayout=TwoPageRight,
    %a4paper=true,
    bookmarks=true,
    bookmarksopen=false,
    bookmarksnumbered=true,
    colorlinks,
    linkcolor=black,%LinkColor,
    citecolor=LinkColor,
    urlcolor=LinkColor
]{hyperref}

\usepackage{glossaries-extra} %Load glossaries package
\usepackage[style=apa, sortcites=false]{biblatex} % style=apa style=authoryear

\addbibresource{main.bib}

\input{chapters/glossary.tex}

% ------------------------

% https://stackoverflow.com/questions/56743092/modifying-settings-json-in-vscode-to-add-shell-escape-flag-to-pdflatex-in-latex
\tikzexternalize[prefix=./tikz/] % To activate the externalization. 

\input{config/margins}

%\input{style/packages}
%\input{style/commonCommands}
%\input{style/pgfplotsettings}
%
%\setcounter{secnumdepth}{3}
%\setcounter{tocdepth}{3}
%
%\tikzexternalize[prefix=externalizedFiles/] % To activate the
%%\tikzset{external/force remake}
%%    \usepackage{showframe}
%
%\drawboundingboxtrue
%\drawboundingboxfalse
%
%\renewcommand{\glossarysection}[2][]{}
%\newglossary{symbols}{sym}{sbl}{List of Symbols}
%\newglossary{functionalAnalysis}{}{}{}
%\newglossary{continuumMechanics}{}{}{}
%\newglossary{fem}{}{}{}
%\newglossary{errorEstimation}{}{}{}
%\newglossary{FCM}{}{}{}
%\newglossary{delamination}{}{}{}
%\newglossary{convectionDiffusion}{}{}{}
%\newglossary{contactMechanics}{}{}{}
%
%\makenoidxglossaries
%\glsnoexpandfields
%\loadglsentries{chapters/glossary/abbreviations.tex}
%\loadglsentries{chapters/glossary/functionalAnalysis.tex}
%\loadglsentries{chapters/glossary/continuumMechanics.tex}
%\loadglsentries{chapters/glossary/fem.tex}
%\loadglsentries{chapters/glossary/errorEstimation.tex}
%\loadglsentries{chapters/glossary/fcm.tex}
%\loadglsentries{chapters/glossary/delamination.tex}
%\loadglsentries{chapters/glossary/convectionDiffusion.tex}
%\loadglsentries{chapters/glossary/contactMechanics.tex}

\begin{document}

%% Title --------------------------------------
\input{chapters/titlePage}
\clearemptydoublepage

%\pagenumbering{roman}
\parindent10pt
\sloppy

% Remove white space above table of contents
\begingroup
\makeatletter
% Redefine the \chapter* header macro to remove vertical space
\def\@makeschapterhead#1{%
  \vspace*{20\p@}% Remove the vertical space
  {\parindent \z@ \raggedright
    \normalfont
    \interlinepenalty\@M
    \Huge \bfseries  #1\par\nobreak
    \vskip 20\p@%\vskip 40\p@
  }}
\makeatother
\tableofcontents
\endgroup

% Abstract --------------------------------------
\input{chapters/abstract}
%\clearemptydoublepage

% Acknowledgments --------------------------------------
\input{chapters/acknowledgments}

% Table of content --------------------------------------
\markright{}

\clearemptydoublepage

%\listoffigures
%\listoftables

%\input{chapters/glossary/glossary.tex}
%
%\clearemptydoublepage
%
%%% Actual Content ---------------------------------

% https://www.youtube.com/watch?v=ofEqFlqkiS0

%\printnoidxglossaries

%\pagenumbering{arabic}

\newcommand\picsDir{}

\input{chapters/01_introduction}
\clearemptydoublepage

\input{chapters/02_formulation}
\clearemptydoublepage

\input{chapters/03_pfem}
\clearemptydoublepage

\input{chapters/04_mlhp}
\clearemptydoublepage

\input{chapters/05_results}
\clearemptydoublepage

\input{chapters/06_conclusion}
\clearemptydoublepage


%\part{Formulation of multi-level $hp$-FEM}
%
%\input{chapters/fundamentalsOfFEM/fundamentalsOfFEM}
%\clearemptydoublepage
%
%\input{chapters/convergenceOfFEM/convergenceOfFEM}
%\clearemptydoublepage
%
%\input{chapters/classicalhp/classicalhp}
%\clearemptydoublepage
%
%\input{chapters/mulilevelhp/multilevelhp}
%\clearemptydoublepage
%
%\input{chapters/implementation/implementation}
%\clearemptydoublepage
%
%\input{chapters/errorestimator/errorestimator.tex}
%\clearemptydoublepage
%
%\part{Application of multi-level $hp$-FEM}
%\input{chapters/examples/examples}
%\clearemptydoublepage
%
%\input{chapters/conclusion/conclusion.tex}
%
%
%% \clearemptydoublepage
%% \appendix
%% 
%% \input{chapters/appendix/errorEstimators/errorEstimators.tex}
%
%%% References -------------------------------------
%%\bibliographystyle{siam}
%\bibliographystyle{apalike}
%% \bibliographystyle{ieeetr}
%\bibliography{library.bib}

\printbibliography 

\end{document}
